%define oname jdk
%define oversion 15.0.2

%define deb_package jdk-%{oversion}_linux-x64_bin.deb


Summary: Oracle java sdk/runtime
Name: java-sun
Version:  16
Release: %mkrel 2
License: Operating System Distributor License for Java (DLJ)
Group: Development/Java
URL: https://www.oracle.com/technetwork/java/javase/downloads/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: binutils xz tar
AutoReqProv: no
#-------------------------------
Obsoletes: java-1.8.0-sun
Obsoletes: java-1.8.0-sun-alsa
Obsoletes: java-1.8.0-sun-devel
Obsoletes: java-1.8.0-sun-fonts
Obsoletes: java-1.8.0-sun-jdbc
Obsoletes: java-1.8.0-sun-plugin
Obsoletes: java-1.8.0-sun-src
#-------------------------------
Obsoletes: atunes
Obsoletes: frostwire
Obsoletes: JSkat
Obsoletes: ytd
#-------------------------------
Provides: java-1.8.0-sun
Provides: java-1.8.0-sun-alsa
Provides: java-1.8.0-sun-devel
Provides: java-1.8.0-sun-fonts
Provides: java-1.8.0-sun-jdbc
Provides: java-1.8.0-sun-plugin
Provides: java-1.8.0-sun-src
#-------------------------------
Provides: java-1.7.0-sun-jdbc
Provides: java-1.8_0-openjdk-jdbc
Provides: java-1.7.0-sun-alsa
Provides: java-1.8_0-openjdk-alsa
Provides: java-1.7.0-sun-fonts 
Provides: java-1.8_0-openjdk-fonts
Provides: java-1.7.0-sun-plugin
Provides: java-1.8_0-openjdk-plugin
Provides: java-1.8_0-openjdk-src
Provides: java-1.7.0-sun-devel
Provides: java-1.8_0-openjdk-devel
Provides: java-1.7.0-sun
Provides: java-1.8_0-openjdk
Provides: java
Provides: jre
Provides: java-devel

%description
The Java(tm) Development Kit (JDK(tm)) contains the software and tools that
developers need to compile, debug, and run applets and applications
written using the Java programming language.


%package src
Summary:        Source files for %{name}
Group:          Development/Java
Requires: %{name}

%description src
This package contains source files for %{name}.



%prep
%setup -T -n %{oname} -c

%build

%install
rm -rf %buildroot
mkdir %buildroot

#export DONT_STRIP=1

#download source
cd $RPM_SOURCE_DIR
wget -nc --no-cookies --no-check-certificate --header "Cookie: oraclelicense=accept-securebackup-cookie" https://download.oracle.com/otn-pub/java/jdk/15.0.2+7/0d1cfde4252546c6931946de8db48ee2/"%{deb_package}" 
cd ..

# extract data from the deb package
ar p $RPM_SOURCE_DIR/%{deb_package} data.tar.xz | xz -d -9 | tar x -C %buildroot

mkdir -p %{buildroot}/%{_sysconfdir}/profile.d
cat >%{buildroot}/%{_sysconfdir}/profile.d/70jdk.sh<< EOF
export J2SDKDIR=/usr/lib/jvm/jdk-%{oversion}
export J2REDIR=/usr/lib/jvm/jdk-%{oversion}
export JAVA_HOME=/usr/lib/jvm/jdk-%{oversion}
export DERBY_HOME=/usr/lib/jvm/jdk-%{oversion}/db
EOF

mkdir -p %{buildroot}/%{_prefix}/lib/jvm-exports

install -d %{buildroot}%{_mandir}/man1
pushd %buildroot/%{_prefix}/lib/jvm/jdk-%{oversion}/man
for manpage in man1/*; do
        iconv -f iso-8859-1 -t utf-8 $manpage -o %{buildroot}%{_mandir}/man1/`basename $manpage .1`-%{name}.1
done
popd

#dump it after processing man pages
rm -rf %{buildroot}/%{_prefix}/lib/jvm/jdk-%{oversion}/man


%clean
rm -rf %buildroot

%pre
#cleanup old junk
rm -rf %{_prefix}/lib/java-*
rm -rf %{_prefix}/lib/jvm-*
rm -rf %{_sysconfdir}/.java


%posttrans
update-alternatives --install /usr/bin/java java /usr/lib/jvm/%{oname}-%{oversion}/bin/java 1
update-alternatives --install /usr/bin/jar jar /usr/lib/jvm/%{oname}-%{oversion}/bin/jar 1
update-alternatives --install /usr/bin/javac javac /usr/lib/jvm/%{oname}-%{oversion}/bin/javac 1

#leftover from update
rm -rf %{_prefix}/lib/jvm/java-1.8.0-sun-1.8.0.162

%postun
update-alternatives --remove java /usr/lib/jvm/%{oname}-%{oversion}/bin/java
update-alternatives --remove jar /usr/lib/jvm/%{oname}-%{oversion}/bin/jar
update-alternatives --remove javac /usr/lib/jvm/%{oname}-%{oversion}/bin/javac


%files
%defattr(-,root,root,-)
%{_prefix}/lib/jvm
%{_datadir}/doc/jdk-%{oversion}/copyright
%{_sysconfdir}/profile.d/70jdk.sh
%{_prefix}/lib/jvm-exports
%{_mandir}
%exclude %{_prefix}/lib/jvm/jdk-%{oversion}/lib/src.zip
%exclude %{_prefix}/lib/jvm/jdk-%{oversion}/include

%files src
%defattr(-,root,root,-)
%{_prefix}/lib/jvm/jdk-%{oversion}/lib/src.zip
%{_prefix}/lib/jvm/jdk-%{oversion}/include

%changelog
* Sat Apr 10 2021 pp 16-2pclos2021
- repackage version 15.0.2

* Fri Mar 19 2021 pp 16-1pclos2021
- update

* Fri Feb 19 2021 pp 15.0.2-1pclos2021
- update

* Tue Nov 10 2020 pp 15.0.1-1pclos2020
- update

* Tue Sep 01 2020 pp 14.0.2-1pclos2020
- update

* Sat Jul 20 2019 pp 12.0.2-1pclos2019
- update

* Wed May 01 2019 tex 12.0.1-2pclos2019
- fix link to javac

* Thu Apr 18 2019 tex 12.0.1-1pclos2019
- fix profile.d
- new version

* Sat Apr 06 2019 tex 12-2pclos2019
- add more obsoletes and provides

* Sat Apr 06 2019 tex 12-1pclos2019
- new
